MODULE aux.

not G   :- G       -> fail | true.
neq N M :- (N = M) -> fail | true.

select ((M,V)::R) M V. 

(select ((N,V)::R) M W) <= 
 neq N M,
 select R M W. 

adjorn ((M,V)::St) M W ((M,W)::St).

(adjorn ((N,V)::St) M W ((N,V)::St1) )<=  
  (neq N M),
  (adjorn St M W St1).
 
adjorn nil M V ((M,V)::nil).

add ((M,V)::St) M W ((M,V)::St).

(add ((N,V)::St) M W ((N,V)::NewSt) ) <= 
  (neq M N), 
  (add St M W NewSt). 

add nil M V ((M,V)::nil). 

initAs ((N,V)::St) ((N,W)::NewSt):-
  write(N),
  write_sans(": Value[y] or Object[class_name]?"),
  read(I),
  (I = y) -> read(W) | 
   (nl,write("> sub-object"),nl,
    new I Ob,
    send Ob init nil W,nl,
    write("> back-to-super-object"),nl),
  initAs St NewSt.
  
initAs nil nil.

writeObj Class (St,Mts) F:-
 write_sans("Object of Class: "),
 write_sans(Class),nl,
 write_sans("attributes: "),nl,
 writeAts St,
 F = n -> (nl,write_sans("methods: "),nl,(writeMts Mts)) | true.

writeAts nil.
      
writeAts ((N,Ob)::Rest):-
  (Ob = (St,Mts)),
  write(N),write_sans(": "),
  nl,write_sans("-----"),nl,   
  writeObj " " Ob s,
  nl,write_sans("-----"),nl,   
  writeAts Rest.   

writeAts ((N,V)::Rest):-
  write(N),write_sans(": "),write(V),nl,
  writeAts Rest.   

writeMts nil.
      
writeMts ((N,D)::Rest):-
  nl,
  write(N),write_sans(" "),writeMt D,nl,
  writeMts Rest.   

writeMt (Body => (m X P R)):-
  write(X),write_sans(" "),write(P),
  write_sans(" --> "),write(R),write_sans(" :-"),nl,
  writeBody(Body).  

writeMt (Body => (p X P)):-
  write(X),write_sans(" "),write(P),
  write_sans(":-"),nl,
  writeBody(Body).  

writeBody Bo:-
  write_sans("  "),
  (Bo = (A,B)) -> 
    (write(A),nl, writeBody(B)) |  
    (write(Bo)).

buildMts Class (Name::R) ((Name,QDef)::Mts):-
 meth Name X Ps V Body ,
 QDef = ((m X Ps V) <= Body),
 buildMts Class R Mts.


buildMts Class (Name::R) ((Name,QDef)::Mts):-
 pred Name X Ps Body,
 QDef = ((p X Ps) <= Body),
 buildMts Class R Mts.

buildMts Class nil nil.

