MODULE gmain.
      
findTrg T P Eps Tr:-
   get  T eps E,
   call T in P,
   checkEps T P E Eps Tr.

checkEps T P E Eps T:-
   E =< Eps.  
   
checkEps T P E Eps Tr:-
   E > Eps,
   write_sans("Lista dei Figli"),nl,
   get  T lx Lx,
   writeTrgList Lx,
   member ST Lx,
   write_sans("Triangolo Selezionato:"),
   nl,
   call ST writeTrg nil,    
   findTrg ST P Eps Tr.

checkEps T P E Eps T:-
   write_sans("Warning: non e' possibile avere precisione < di "),
   write(E),nl.

start :-
  write_sans("Inserisci dati del triangolo:"),nl,
  build_triangulation T,
  call T writeTrg nil,
  write_sans("Inserisci punto:"),nl,
  new_point P,
  write_sans("Inserisci precisione:"),read(Eps), 
  findTrg T P Eps Tr,
  write_sans("Triangolo massimale"),     
  call Tr writeTrg nil.


thetriangle PVT:-
 new point P,
 new point Qi,
 new point Ri,
 new point Si,
 new point Ti,
 new point Vi, 
 new triangle PQRi,
 new triangle QSRi,
 new triangle STRi,
 new triangle PSRi,
 new triangle SVTi,
 new triangle PSTi,
 new triangle PVTi,
 initPt (2,0) Qi Q,
 initPt (2,2) Ri R,
 initPt (4,0) Si S,
 initPt (4,4) Ti T,
 initPt (8,0) Vi V,
 initTrg P Q R 1 nil             PQRi PQR,
 initTrg Q S R 1 nil             QSRi QSR,
 initTrg S T R 2 nil             STRi STR,
 initTrg P S R 2 (PQR::QSR::nil) PSRi PSR,
 initTrg S V T 3 nil             SVTi SVT,
 initTrg P S T 3 (PSR::STR::nil) PSTi PST,
 initTrg P V T 4 (PST::SVT::nil) PVTi PVT.

d:-
 thetriangle T,
 call T writeTrg nil.

demo :- 
  write_sans("Triangolo iniziale:"),nl,
  loadT T,
  call T writeTrg nil,
  write_sans("Punto iniziale: (4,2)"),nl,   
  new point Pi,
  initPt (3,1) Pi P,
  Eps = 2,
  write_sans("Precisione: "),write(Eps),nl,    
  findTrg T P Eps Tr,
  write_sans("Triangolo massimale"),     
  call Tr writeTrg nil.

save:- 
  Goal = (thetriangle T,write T),
  telling "input.ll" Goal.  

loadT T:- 
  seeing "input.ll" (read T).   


