MODULE obj.

new Class (St,Mts):-
   (class Class St MtNs) -> true | 
      (nl,write_sans ("Error: Class "),
          write(Class),
          write_sans(" is not defined"),
       nl,fail), 
   buildMts Class (MtNs) Mts. 

get Ob M V:-
 Ob = (St,Mts),  
 select St M V.

get Ob M V:-
 Ob = (g Oo Mo),  
 get Oo Mo Oi,
 get Oi M V.

update (St,Mts) M V (NewSt,Mts):-
  adjorn St M V NewSt.

enrich (St,Mts) M V (NewSt,Mts):-
  add St M V NewSt.

send Ob M P V:-
 Ob = (St,Mts),
 select Mts M Def, 
 generalize Def QDef,
 QDef -o (m Ob P V).

send Ob M P V:-  
 Ob = (s Oo Mo Po),
 send Oo Mo Po Oi,
 send Oi M P V.

call Ob M P:-
 Ob = (St,Mts), 
 select Mts M Def,
 generalize Def QDef, 
 QDef -o (p Ob P).

override (St,Mts) M Def (St,NewMts):-
  adjorn Mts M Def NewMts.

extend (St,Mts) M Def (St,NewMts):-
  add Mts M Def NewMts.

init (St,Mts) (NewSt,Mts):-
  initAs St NewSt.

pred write Self nil (  
  writeObj Class Self n  
).

pred swrite Self nil (  
  writeObj Class Self s  
).

meth init Self nil InitSelf (
  init Self InitSelf 
).


